%  KDR line learch routine
%
%

function [Bn tr] = KDRline(X,Ky,sz2,B,dB,eta,EPS)

options = optimset('Display', 'off', 'MaxIter',30);

N=length(X(:,1));
K=length(B(1,:));
unit = ones(N,N);

[s tr] = fminbnd(@kdr1dim,0,eta,options);

Bn = B-s*dB;

    function t=kdr1dim(s);
        tmpB=B-s*dB;
        [tmpB,D,V]=svd(tmpB,0);
        Z=X*tmpB;
        ab=Z*Z';
        D=repmat(diag(ab),1,N);
        Kz=exp((-D-D'+2*ab)./sz2);  
        mK=mean(Kz,2);
        rK=repmat(mK,1,N);
        Kz=Kz-rK-rK'+mean(mK,1)*unit;     
        mz=inv(Kz+N*EPS.*eye(N));
        t=sum(sum(Ky.*mz,1),2);
    end
end


